// 导入Joystick脚本
import joy from "./Joystick"

import { _decorator, Component, Node, math, EventTouch, RigidBody, CCFloat, Vec2, log, Vec3 } from 'cc';
const { ccclass, property } = _decorator;


@ccclass('ship01')
export default class ship01 extends Component {

    @property({ displayName: "摇杆脚本所在节点", tooltip: "摇杆脚本Joystick所在脚本", type: joy })
    joy: joy = null!;


    @property({ displayName: "角色", tooltip: "角色", type: Node })
    player: Node = null!;



    @property({ displayName: "旋转速度", tooltip: "速度" })
    speed: number = 10;


    @property({ displayName: "刚体", tooltip: "刚体", type: RigidBody })
    gangti: RigidBody = null!;

    // 角色旋转的角度
    angle: number = 0;

    is_forward = false;

    update(dt) {
        // console.log("vector", this.vector.toString(), "angle", this.angle);

        // 获取角色旋转的角度
        this.angle = this.joy.angle;
        // 对角色进行旋转
        var bb: math.Quat = new math.Quat();
        this.player.getRotation(bb);


        var aa: Vec3 = new Vec3();
        bb.getEulerAngles(aa);
        if (aa.y > 360) {
            aa.y -= 360;
        } else if (aa.y <= 0) {
            aa.y += 360;
        }

        var _to_y = this.angle - 90;
        if (_to_y > 360) {
            _to_y -= 360;
        } else if (_to_y <= 0) {
            _to_y += 360;
        }

        var _del2 = Math.abs(aa.y - _to_y);
        if (_del2 < 180) {
            if (aa.y > _to_y) {
                aa.y -= this.speed * dt;
            } else {
                aa.y += this.speed * dt;
            }
        } else {
            if (aa.y > _to_y) {
                aa.y += this.speed * dt;
            } else {
                aa.y -= this.speed * dt;
            }
        }




        // log(_to_y);

        this.player.setRotationFromEuler(aa);


        if (this.is_forward) {

            // 根据当前角度将力度向量分配到 xz 轴

            // 根据角度计算
            var h1 = aa.y * Math.PI / 180;
            var _x = Math.sin(h1);
            var _y = Math.cos(h1);
            this.gangti.applyForce(new Vec3(-1 * _x, 0, -1 * _y));
        }
    }


    btn_forward() {
        this.is_forward = true;
    }

    off_worward() {
        this.is_forward = false;
    }

}